diff -pruN 4.7r-1/aclocal.m4 4.7s-1/aclocal.m4
--- 4.7r-1/aclocal.m4	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/aclocal.m4	2021-03-05 02:05:42.000000000 +0000
@@ -1,4 +1,4 @@
-dnl $Id: aclocal.m4,v 4.34 2021/01/10 21:05:39 tom Exp $
+dnl $Id: aclocal.m4,v 4.35 2021/01/13 21:51:52 tom Exp $
 dnl
 dnl Macros for cproto configure script
 dnl ---------------------------------------------------------------------------
@@ -1381,7 +1381,7 @@ $1=`echo "$2" | \
 		-e 's/-[[UD]]'"$3"'\(=[[^ 	]]*\)\?[$]//g'`
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_SIZE_T version: 5 updated: 2013/12/05 19:11:11
+dnl CF_SIZE_T version: 6 updated: 2021/01/10 18:23:00
 dnl ---------
 dnl	On both Ultrix and CLIX, I find size_t defined in <stdio.h>
 AC_DEFUN([CF_SIZE_T],
@@ -1400,7 +1400,7 @@ AC_CACHE_VAL(cf_cv_type_size_t,[
 		[cf_cv_type_size_t=no])
 	])
 AC_MSG_RESULT($cf_cv_type_size_t)
-test $cf_cv_type_size_t = no && AC_DEFINE(size_t, unsigned, [Define to type if size_t not declared])
+test "$cf_cv_type_size_t" = no && AC_DEFINE(size_t, unsigned, [Define to type if size_t not declared])
 ])dnl
 dnl ---------------------------------------------------------------------------
 dnl CF_TRY_XOPEN_SOURCE version: 2 updated: 2018/06/20 20:23:13
@@ -1459,7 +1459,7 @@ AC_DEFUN([CF_VERBOSE],
 CF_MSG_LOG([$1])
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_WITHOUT_X version: 2 updated: 2020/10/04 10:05:20
+dnl CF_WITHOUT_X version: 3 updated: 2021/01/13 16:51:52
 dnl ------------
 dnl Use this to cancel the check for X headers/libraries which would be pulled
 dnl in via CF_GCC_WARNINGS.
@@ -1468,6 +1468,8 @@ AC_DEFUN([AC_PATH_XTRA],[])
 AC_DEFUN([CF_SAVE_XTRA_FLAGS],[])
 AC_DEFUN([CF_RESTORE_XTRA_FLAGS],[])
 AC_DEFUN([CF_CONST_X_STRING],[echo "skipping X-const check";])dnl
+AC_SUBST(X_CFLAGS)
+AC_SUBST(X_LIBS)
 [])dnl
 dnl ---------------------------------------------------------------------------
 dnl CF_WITH_DBMALLOC version: 7 updated: 2010/06/21 17:26:47
diff -pruN 4.7r-1/CHANGES 4.7s-1/CHANGES
--- 4.7r-1/CHANGES	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/CHANGES	2021-03-05 02:05:42.000000000 +0000
@@ -1,4 +1,11 @@
--- $Id: CHANGES,v 4.61 2021/01/10 16:46:10 tom Exp $
+-- $Id: CHANGES,v 4.63 2021/03/04 01:25:12 tom Exp $
+
+2021/03/03 (4.7s)
+- ignore preprocessor output with zero line-numbers.
+- add some null-pointer checks in lintlibs.c, to work with compilers emitting
+  unconventional proprocessor-lines.
+- add .c.i rule to makefile
+- updated configure macros
 
 2021/01/10 (4.7r)
 - add -n and -N options (prompted by discussion with "Radisson97").
diff -pruN 4.7r-1/configure 4.7s-1/configure
--- 4.7r-1/configure	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/configure	2021-03-05 02:05:42.000000000 +0000
@@ -6207,7 +6207,7 @@ fi
 
 echo "$as_me:6208: result: $cf_cv_type_size_t" >&5
 echo "${ECHO_T}$cf_cv_type_size_t" >&6
-test $cf_cv_type_size_t = no &&
+test "$cf_cv_type_size_t" = no &&
 cat >>confdefs.h <<\EOF
 #define size_t unsigned
 EOF
@@ -7895,6 +7895,8 @@ if test -n "\$CONFIG_FILES"; then
   # Protect against being on the right side of a sed subst in config.status.
   sed 's/,@/@@/; s/@,/@@/; s/,;t t\$/@;t t/; /@;t t\$/s/[\\\\&,]/\\\\&/g;
    s/@@/,@/; s/@@/@,/; s/@;t t\$/,;t t/' >\$tmp/subs.sed <<\\CEOF
+s,@X_CFLAGS@,$X_CFLAGS,;t t
+s,@X_LIBS@,$X_LIBS,;t t
 s,@SHELL@,$SHELL,;t t
 s,@exec_prefix@,$exec_prefix,;t t
 s,@prefix@,$prefix,;t t
@@ -8110,7 +8112,7 @@ done; }
   esac
 
   if test x"$ac_file" != x-; then
-    { echo "$as_me:8113: creating $ac_file" >&5
+    { echo "$as_me:8115: creating $ac_file" >&5
 echo "$as_me: creating $ac_file" >&6;}
     rm -f "$ac_file"
   fi
@@ -8128,7 +8130,7 @@ echo "$as_me: creating $ac_file" >&6;}
       -) echo $tmp/stdin ;;
       [\\/$]*)
          # Absolute (can't be DOS-style, as IFS=:)
-         test -f "$f" || { { echo "$as_me:8131: error: cannot find input file: $f" >&5
+         test -f "$f" || { { echo "$as_me:8133: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          echo $f;;
@@ -8141,7 +8143,7 @@ echo "$as_me: error: cannot find input f
            echo "$srcdir/$f"
          else
            # /dev/null tree
-           { { echo "$as_me:8144: error: cannot find input file: $f" >&5
+           { { echo "$as_me:8146: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          fi;;
@@ -8157,7 +8159,7 @@ cat >>"$CONFIG_STATUS" <<\EOF
       if test -n "$ac_seen"; then
         ac_used=`grep '@datarootdir@' "$ac_item"`
         if test -z "$ac_used"; then
-          { echo "$as_me:8160: WARNING: datarootdir was used implicitly but not set:
+          { echo "$as_me:8162: WARNING: datarootdir was used implicitly but not set:
 $ac_seen" >&5
 echo "$as_me: WARNING: datarootdir was used implicitly but not set:
 $ac_seen" >&2;}
@@ -8166,7 +8168,7 @@ $ac_seen" >&2;}
       fi
       ac_seen=`grep '${datarootdir}' "$ac_item"`
       if test -n "$ac_seen"; then
-        { echo "$as_me:8169: WARNING: datarootdir was used explicitly but not set:
+        { echo "$as_me:8171: WARNING: datarootdir was used explicitly but not set:
 $ac_seen" >&5
 echo "$as_me: WARNING: datarootdir was used explicitly but not set:
 $ac_seen" >&2;}
@@ -8203,7 +8205,7 @@ s,@INSTALL@,$ac_INSTALL,;t t
             ac_init=`${EGREP-egrep} '[ 	]*'$ac_name'[ 	]*=' "$ac_file"`
             if test -z "$ac_init"; then
               ac_seen=`echo "$ac_seen" |sed -e 's,^,'$ac_file':,'`
-              { echo "$as_me:8206: WARNING: Variable $ac_name is used but was not set:
+              { echo "$as_me:8208: WARNING: Variable $ac_name is used but was not set:
 $ac_seen" >&5
 echo "$as_me: WARNING: Variable $ac_name is used but was not set:
 $ac_seen" >&2;}
@@ -8214,7 +8216,7 @@ $ac_seen" >&2;}
     ${EGREP-egrep} -n '@[A-Z_][A-Z_0-9]+@' "$ac_file" >>$tmp/out
     if test -s $tmp/out; then
       ac_seen=`sed -e 's,^,'$ac_file':,' < $tmp/out`
-      { echo "$as_me:8217: WARNING: Some variables may not be substituted:
+      { echo "$as_me:8219: WARNING: Some variables may not be substituted:
 $ac_seen" >&5
 echo "$as_me: WARNING: Some variables may not be substituted:
 $ac_seen" >&2;}
@@ -8263,7 +8265,7 @@ for ac_file in : $CONFIG_HEADERS; do tes
   * )   ac_file_in=$ac_file.in ;;
   esac
 
-  test x"$ac_file" != x- && { echo "$as_me:8266: creating $ac_file" >&5
+  test x"$ac_file" != x- && { echo "$as_me:8268: creating $ac_file" >&5
 echo "$as_me: creating $ac_file" >&6;}
 
   # First look for the input files in the build tree, otherwise in the
@@ -8274,7 +8276,7 @@ echo "$as_me: creating $ac_file" >&6;}
       -) echo $tmp/stdin ;;
       [\\/$]*)
          # Absolute (can't be DOS-style, as IFS=:)
-         test -f "$f" || { { echo "$as_me:8277: error: cannot find input file: $f" >&5
+         test -f "$f" || { { echo "$as_me:8279: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          echo $f;;
@@ -8287,7 +8289,7 @@ echo "$as_me: error: cannot find input f
            echo "$srcdir/$f"
          else
            # /dev/null tree
-           { { echo "$as_me:8290: error: cannot find input file: $f" >&5
+           { { echo "$as_me:8292: error: cannot find input file: $f" >&5
 echo "$as_me: error: cannot find input file: $f" >&2;}
    { (exit 1); exit 1; }; }
          fi;;
@@ -8345,7 +8347,7 @@ cat >>"$CONFIG_STATUS" <<\EOF
   rm -f $tmp/in
   if test x"$ac_file" != x-; then
     if cmp -s "$ac_file" "$tmp/config.h" 2>/dev/null; then
-      { echo "$as_me:8348: $ac_file is unchanged" >&5
+      { echo "$as_me:8350: $ac_file is unchanged" >&5
 echo "$as_me: $ac_file is unchanged" >&6;}
     else
       ac_dir=`$as_expr X"$ac_file" : 'X\(.*[^/]\)//*[^/][^/]*/*$' \| \
diff -pruN 4.7r-1/cproto.1 4.7s-1/cproto.1
--- 4.7r-1/cproto.1	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/cproto.1	2021-03-05 02:05:42.000000000 +0000
@@ -1,4 +1,4 @@
-.\" $Id: cproto.1,v 4.11 2021/01/10 17:02:13 tom Exp $
+.\" $Id: cproto.1,v 4.13 2021/03/03 22:27:37 tom Exp $
 .\"
 .de Ex
 .RS +7
@@ -15,7 +15,7 @@
 .el       .ds `` ``
 .ie \n(.g .ds '' \(rq
 .el       .ds '' ''
-.TH CPROTO 1 "2021-01-10" "Version 4.7r" "USER COMMANDS"
+.TH CPROTO 1 "2021-03-03" "Version 4.7s" "USER COMMANDS"
 .
 .SH NAME
 cproto \- generate C function prototypes and convert function definitions
@@ -188,7 +188,7 @@ The default is \*(``P_\*(''.
 Rather than filling in \*(``void\*('' for functions without parameters,
 use a comment \*(``/*empty*/\*(''.
 .TP
-.BI \-m " name"
+.BI \-N " name"
 Rather than filling in \*(``void\*('' for functions without parameters,
 use the given \fIname\fP.
 .TP
diff -pruN 4.7r-1/cproto.c 4.7s-1/cproto.c
--- 4.7r-1/cproto.c	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/cproto.c	2021-03-05 02:05:42.000000000 +0000
@@ -1,8 +1,8 @@
-/* $Id: cproto.c,v 4.50 2021/01/10 16:28:12 tom Exp $
+/* $Id: cproto.c,v 4.51 2021/03/03 22:04:59 tom Exp $
  *
  * C function prototype generator and function definition converter
  */
-#define VERSION "4.7r"
+#define VERSION "4.7s"
 
 #include <cproto.h>
 
diff -pruN 4.7r-1/debian/changelog 4.7s-1/debian/changelog
--- 4.7r-1/debian/changelog	2021-01-10 22:58:57.000000000 +0000
+++ 4.7s-1/debian/changelog	2021-03-05 02:06:41.000000000 +0000
@@ -1,3 +1,10 @@
+cproto (4.7s-1) unstable; urgency=medium
+
+  * New upstream release.
+    - Includes fixes for FTBFS with gcc-11 (closes: #984023)
+
+ -- Kenneth J. Pronovici <pronovic@debian.org>  Fri, 05 Mar 2021 02:06:41 +0000
+
 cproto (4.7r-1) unstable; urgency=medium
 
   * New upstream release.
diff -pruN 4.7r-1/grammar.y 4.7s-1/grammar.y
--- 4.7r-1/grammar.y	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/grammar.y	2021-03-05 02:05:42.000000000 +0000
@@ -1,4 +1,4 @@
-/* $Id: grammar.y,v 4.25 2020/10/11 17:57:51 tom Exp $
+/* $Id: grammar.y,v 4.26 2021/03/04 00:43:45 tom Exp $
  *
  * yacc grammar for C function prototype generator
  * This was derived from the grammar in Appendix A of
@@ -986,6 +986,34 @@ init_parser(void)
     }
 }
 
+#ifdef DEBUG_YYIN
+static FILE *
+copyfile(FILE *input, const char *name)
+{
+    FILE *output;
+    char my_filename[1024];
+    int n;
+    int ch;
+    for (n = 0; n < 999; ++n) {
+	sprintf(my_filename, "%s.gen%03d", name, n);
+	if ((output = fopen(my_filename, "r")) != 0) {
+	    fclose(output);
+	} else {
+	    break;
+	}
+    }
+    if ((output = fopen(my_filename, "w")) != 0) {
+	while ((ch = fgetc(input)) != EOF) {
+	    if (ferror(input))
+		break;
+	    fputc(ch, output);
+	}
+	fclose(output);
+    }
+    return fopen(my_filename, "r");
+}
+#endif /* DEBUG_YYIN */
+
 /* Process the C source file.  Write function prototypes to the standard
  * output.  Convert function definitions and write the converted source
  * code to a temporary file.
@@ -1015,7 +1043,11 @@ process_file(FILE *infile, const char *n
     curly = 0;
     ly_count = 0;
     func_params = NULL;
+#ifdef DEBUG_YYIN
+    yyin = copyfile(infile, name);
+#else
     yyin = infile;
+#endif
     include_file(strcpy(base_file, name), func_style != FUNC_NONE);
     if (file_comments) {
 #if OPT_LINTLIBRARY
diff -pruN 4.7r-1/lex.l 4.7s-1/lex.l
--- 4.7r-1/lex.l	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/lex.l	2021-03-05 02:05:42.000000000 +0000
@@ -2,7 +2,7 @@
 
 %{
 
-/* $Id: lex.l,v 4.28 2021/01/10 15:50:35 tom Exp $
+/* $Id: lex.l,v 4.29 2021/03/04 00:43:22 tom Exp $
  *
  * Lexical analyzer for C function prototype generator
  *
@@ -161,34 +161,46 @@ QUOTE		[\"\']
 			}
 
 <CPP1>line{WS}+[0-9]+{WS}+\".*$  {
+			    unsigned line_num;
+
 			    save_text();
 
 			    parsing_file_name((unsigned) yyleng);
 			    sscanf(yytext, "line %u \"%[^\"]\"",
-					   &cur_file->line_num,
+					   &line_num,
 					   cur_file->file_name);
 
-			    cur_file->line_num--;
-			    track_in();
+			    if (line_num > 0) {
+				cur_file->line_num = line_num - 1;
+				track_in();
+			    }
 			    finishCpp();
 			}
 <CPP1>[0-9]+{WS}+\".*$  {
+			    unsigned line_num;
+
 			    save_text();
 
 			    parsing_file_name((unsigned) yyleng);
 			    sscanf(yytext, "%u \"%[^\"]\"",
-					   &cur_file->line_num,
+					   &line_num,
 					   cur_file->file_name);
 
-			    cur_file->line_num--;
-			    track_in();
+			    if (line_num > 0) {
+				cur_file->line_num = line_num - 1;
+				track_in();
+			    }
 			    finishCpp();
 			}
 <CPP1>[0-9]+.*$ 	{
+			    unsigned line_num;
+
 			    save_text();
-			    sscanf(yytext, "%u ", &cur_file->line_num);
-			    cur_file->line_num--;
-			    track_in();
+			    sscanf(yytext, "%u ", &line_num);
+			    if (line_num > 0) {
+				cur_file->line_num = line_num - 1;
+				track_in();
+			    }
 			    finishCpp();
 			}
 
diff -pruN 4.7r-1/lintlibs.c 4.7s-1/lintlibs.c
--- 4.7r-1/lintlibs.c	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/lintlibs.c	2021-03-05 02:05:42.000000000 +0000
@@ -1,4 +1,4 @@
-/* $Id: lintlibs.c,v 4.21 2011/01/02 19:24:03 tom Exp $
+/* $Id: lintlibs.c,v 4.22 2021/03/03 23:44:49 tom Exp $
  *
  * C prototype/lint-library generator
  * These routines implement the semantic actions for lint libraries executed by
@@ -277,7 +277,7 @@ ignored(char *path)
 static const char *
 skip_dot(const char *a)
 {
-    if (!strncmp(a, "./", (size_t) 2))
+    if (a != NULL && !strncmp(a, "./", (size_t) 2))
 	a += 2;
     return a;
 }
@@ -285,7 +285,7 @@ skip_dot(const char *a)
 static int
 same_file(const char *a, const char *b)
 {
-    return !strcmp(skip_dot(a), skip_dot(b));
+    return (a != NULL && b != NULL) ? !strcmp(skip_dot(a), skip_dot(b)) : 0;
 }
 
 /*
@@ -350,6 +350,7 @@ track_in(void)
 #ifdef DEBUG
 	char temp[80];
 #endif
+	char *inc_file;
 
 	flush_varargs();
 	for (n = in_include, found = FALSE; (int) n >= 0; n--) {
@@ -391,7 +392,8 @@ track_in(void)
 #endif
 	    }
 	}
-	(void) strcpy(old_file, get_inc_stack(in_include));
+	inc_file = get_inc_stack(in_include);
+	(void) strcpy(old_file, inc_file ? inc_file : "");
     }
 #ifdef	DEBUG
     dump_stack("-after");
diff -pruN 4.7r-1/Makefile.in 4.7s-1/Makefile.in
--- 4.7r-1/Makefile.in	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/Makefile.in	2021-03-05 02:05:42.000000000 +0000
@@ -1,9 +1,9 @@
-# $Id: Makefile.in,v 4.34 2021/01/10 12:01:55 tom Exp $
+# $Id: Makefile.in,v 4.36 2021/03/03 23:53:08 tom Exp $
 #
 # UNIX template-makefile for C prototype generator
 
 THIS = cproto
-RELEASE = 4_7r
+RELEASE = 4_7s
 
 #### Start of system configuration section. ####
 
@@ -41,6 +41,8 @@ MANDIR		= $(DESTDIR)$(mandir)/man$(manex
 x		= @EXEEXT@
 o		= .@OBJEXT@
 
+.SUFFIXES:	.c $o .i
+
 TEST_REF	= .
 
 #### End of system configuration section. ####
@@ -107,6 +109,10 @@ uninstall:
 	@RULE_CC@
 	@ECHO_CC@$(CC) -c $(CFLAGS) $(CPPFLAGS) $<
 
+.c.i:
+	@RULE_CC@
+	@ECHO_CC@$(CPP) $(CPPFLAGS) $< >$*.i
+
 $(PROG) : $(OBJECTS)
 	@ECHO_LD@$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(OBJECTS) $(LIBS)
 
@@ -117,7 +123,7 @@ lex.yy.c : lex.l
 	$(LEX) $(srcdir)/lex.l
 
 mostlyclean ::
-	- rm -f core .nfs* *$o *.bak *.BAK *.out $(JUNK) default.h
+	- rm -f core .nfs* *$o *.i *.bak *.BAK *.out $(JUNK) default.h
 
 clean :: mostlyclean
 	- rm -f $(PROG)
diff -pruN 4.7r-1/MANIFEST 4.7s-1/MANIFEST
--- 4.7r-1/MANIFEST	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/MANIFEST	2021-03-05 02:05:42.000000000 +0000
@@ -1,4 +1,4 @@
-MANIFEST for cproto-4.7r, version v4_7r
+MANIFEST for cproto-4.7s, version v4_7s
 --------------------------------------------------------------------------------
 MANIFEST                        this file
 AUTHORS                         authors
diff -pruN 4.7r-1/package/cproto.spec 4.7s-1/package/cproto.spec
--- 4.7r-1/package/cproto.spec	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/package/cproto.spec	2021-03-05 02:05:42.000000000 +0000
@@ -1,7 +1,7 @@
 Summary:  cproto - generate C function prototypes and convert function definitions
 %define AppProgram cproto
-%define AppVersion 4.7r
-# $Id: cproto.spec,v 1.12 2021/01/10 12:01:55 tom Exp $
+%define AppVersion 4.7s
+# $Id: cproto.spec,v 1.13 2021/03/03 22:04:59 tom Exp $
 Name: %{AppProgram}
 Version: %{AppVersion}
 Release: 1
diff -pruN 4.7r-1/package/debian/changelog 4.7s-1/package/debian/changelog
--- 4.7r-1/package/debian/changelog	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/package/debian/changelog	2021-03-05 02:05:42.000000000 +0000
@@ -1,3 +1,9 @@
+cproto (4.7s) unstable; urgency=low
+
+  * maintenance updates
+
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Wed, 03 Mar 2021 17:04:59 -0500
+
 cproto (4.7r) unstable; urgency=low
 
   * maintenance updates
diff -pruN 4.7r-1/package/debian/compat 4.7s-1/package/debian/compat
--- 4.7r-1/package/debian/compat	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/package/debian/compat	2021-03-05 02:05:42.000000000 +0000
@@ -1 +1 @@
-5
+10
diff -pruN 4.7r-1/package/debian/control 4.7s-1/package/debian/control
--- 4.7r-1/package/debian/control	2021-01-10 22:58:53.000000000 +0000
+++ 4.7s-1/package/debian/control	2021-03-05 02:05:42.000000000 +0000
@@ -1,7 +1,7 @@
 Source: cproto
 Maintainer: Thomas E. Dickey <dickey@invisible-island.net>
 Section: devel
-Priority: extra
+Priority: optional
 Standards-Version: 3.8.4
 Build-Depends: debhelper (>= 5)
 Homepage: http://invisible-island.net/cproto/
